c# **************************************************************************
# Copyright (C) 2005 Francois Audirac <francois.audirac@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# ***************************************************************************
# File  : import_demo
# Author  : Francois AUDIRAC
#           mailto:francois@webaf.net
#           http://www.webaf.net
# Date    : 22/10/2010
# Licence : GNU/GPL Version 2
#
# Description:
# ------------
#
# @version    $Id: import_demo.sh,v 0.2 2010/01/22 0:00:00 
# @author     Francois Audirac
# @project   
# @copyright  Francois Audirac 30/08/2006
#
# Teste et adapte pour AbulEdu 8.08 et 9.08
# ************************************************************************* */
# Script de creation automatique de comptes pour serveur AbulEdu de démo
# Interface script pour installation et desinstallation
# utilisant zenity pour faire zoli

# TODO
# - prévoir de demander dans le script : le nom du groupe
# - prévoir de demander le mot de passe par defaut
# - prévoir de demander le type de démo : ecole ou association
# - distinguer le cas AbulEdu 8.08 et 9.08

#!/bin/sh
################### VARIABLES #########################"
# version du script
VERSION="0.2"
# nom du groupe par defaut 
GROUPEDEMO="groupeclasse"

# valeur du mot de passe par défaut.
MOTDEPASSE="entre"
PROFILE="utilisateurs"
# Fichiers du profil à copier
PROFILEFILES=".bash_logout .bashrc .config .dmrc .gconf .gconfd .gnome2 .icons .kde .local .themes"
 
# Liste des comptes responsables
RESPLIST="9 10 16 17 18 19 20 31 32 33 34 35 36 37 38 39 40"

# privilèges supplémentaires des responsables
GROUPSUPP="leterrier:lpadmin-ldap:webmestres"

# Liste des utilisateurs (à modifier selon les besoins)

# Structure scolaire
USERSDEMO[1]="mat:ecole:/usr/share/skels/users/xfce_maternelle"
USERSDEMO[2]="cycle2:ecole:/usr/share/skels/users/xfce_cycle2"
USERSDEMO[3]="cycle2jeux:ecole:/usr/share/skels/users/xfce_cycle2-avec-jeux"
USERSDEMO[4]="cycle3:ecole:/usr/share/skels/users/xfce_cycle3"
USERSDEMO[5]="cycle3jeux:ecole:/usr/share/skels/users/xfce_cycle3-avec-jeux"
USERSDEMO[6]="college:ecole:/usr/share/skels/users/xfce_college"
USERSDEMO[7]="gnomeeleves:ecole:/usr/share/skels/users/gnome-eleves"
USERSDEMO[8]="gnomenormal:ecole:/usr/share/skels/users/gnome-normal"
USERSDEMO[9]="instit:ecole:/usr/share/skels/users/gnome-normal"
USERSDEMO[10]="prof:ecole:/usr/share/skels/users/gnome-normal"

# structure animation educ-pop
# usagers
USERSDEMO[11]="usager1:assoc:/usr/share/skels/users/xfce_cycle3-avec-jeux"
USERSDEMO[12]="usager2:assoc:/usr/share/skels/users/xfce_cycle3-avec-jeux"
USERSDEMO[13]="usager3:assoc:/usr/share/skels/users/xfce_cycle3-avec-jeux"
USERSDEMO[14]="usager4:assoc:/usr/share/skels/users/xfce_cycle3-avec-jeux"
USERSDEMO[15]="usager5:assoc:/usr/share/skels/users/xfce_cycle3-avec-jeux"
# responsables
USERSDEMO[16]="resp1:assoc:/usr/share/skels/users/gnome-normal"
USERSDEMO[17]="resp2:assoc:/usr/share/skels/users/gnome-normal"
USERSDEMO[18]="resp3:assoc:/usr/share/skels/users/gnome-normal"
USERSDEMO[19]="resp4:assoc:/usr/share/skels/users/gnome-normal"
USERSDEMO[20]="resp5:assoc:/usr/share/skels/users/gnome-normal"

# structure demo ENR
# élèves
USERSDEMO[21]="eleve1:ecole:/usr/share/skels/users/cycle1"
USERSDEMO[22]="eleve2:ecole:/usr/share/skels/users/cycle1"
USERSDEMO[23]="eleve3:ecole:/usr/share/skels/users/cycle1"
USERSDEMO[24]="eleve4:ecole:/usr/share/skels/users/cycle2"
USERSDEMO[25]="eleve5:ecole:/usr/share/skels/users/cycle2"
USERSDEMO[26]="eleve6:ecole:/usr/share/skels/users/cycle2"
USERSDEMO[27]="eleve7:ecole:/usr/share/skels/users/cycle3"
USERSDEMO[28]="eleve8:ecole:/usr/share/skels/users/cycle3"
USERSDEMO[29]="eleve9:ecole:/usr/share/skels/users/cycle3"
USERSDEMO[30]="eleve10:ecole:/usr/share/skels/users/cycle3"
# instits
USERSDEMO[31]="instit1:ecole:/usr/share/skels/users/enseignant"
USERSDEMO[32]="instit2:ecole:/usr/share/skels/users/enseignant"
USERSDEMO[33]="instit3:ecole:/usr/share/skels/users/enseignant"
USERSDEMO[34]="instit4:ecole:/usr/share/skels/users/enseignant"
USERSDEMO[35]="instit5:ecole:/usr/share/skels/users/enseignant"
USERSDEMO[36]="instit6:ecole:/usr/share/skels/users/enseignant"
USERSDEMO[37]="instit7:ecole:/usr/share/skels/users/enseignant"
USERSDEMO[38]="instit8:ecole:/usr/share/skels/users/enseignant"
USERSDEMO[39]="instit9:ecole:/usr/share/skels/users/enseignant"
USERSDEMO[40]="instit10:ecole:/usr/share/skels/users/enseignant"


# structure 

# Utilisateur propriétaire des fichiers
RESP=10

# On calcule le nombre de comptes
# (remplacé par le choix du menu initial)
# NBCOMPTES=${#USERSDEMO[*]}

MAXCOMPTES=${#USERSDEMO[*]}


# Initialise colors
if [ ! "${nocolor}" ]; then
    NO="\x1b[0;0m"
    BR="\x1b[0;01m"
    CY="\x1b[36;01m"
    RD="\x1b[31;01m"
    GR="\x1b[32;01m"
    YL="\x1b[33;01m"
    BL="\x1b[34;01m"
    STAR=" *"
    BRSTAR="${BR}${STAR}${NO}"
    RDSTAR="${RD}${STAR}${NO}"
    BLSTAR="${BL}${STAR}${NO}"
    YLSTAR="${YL}${STAR}${NO}"
    GRSTAR="${GR}${STAR}${NO}"
fi


# Test du compte root
ME=`whoami`
if [ "$ME" != "root" ] ; then
	echo -e "${RDSTAR}" "${RD}" "ERREUR !" "${NO}${RDSTAR}"
	echo -e "Merci de lancer ce script en tant que ${RD}root${NO}."
	exit 1;
fi
	
REPONSE=""
while [ "$REPONSE" == "" ]; do
# Interface d'accueil avec menu : A tester
#   REPONSE=`zenity --list --title="Installation / Désinstallation" --height=400 --text="Grâce à cette interface vous pouvez créer des comptes spécifiques à une
# <b>démonstration de serveur AbulEdu</b> et y ajouter des outils.
# Vous pourrez aussi facilement les enlever et retrouver un serveur
# identique au départ.

# Cet outil crée 40 comptes utilisateurs, ainsi qu'un groupe \"groupedemo\"
# Des fichiers sont déposés pour permettre d'utiliser ce serveur dans le
# cadre d'une démonstration (diaporama, images, documentation...) .
# D'autres informations spécifiques (listes des utilisateurs, profils, 
# fichiers..) se trouvent dans le dossier \"groupedemo\" / \"outils\" 

# " --hide-column="1" --column="choix" --column "Que voulez-vous faire ?" \
# "I" "Installer les comptes et fichiers de démonstration" \
# "D" "Désinstaller les comptes et fichiers de démonstration" \
# "Q" "Quitter"`

echo -e "** ${GR}Création automatique de comptes utilisateurs ${NO}**
Voulez-vous créer des comptes pour simuler :
	\"E\" une ÉCOLE
	\"R\" une ÉCOLE NUMÉRIQUE RURALE (ENR)
	\"A\" une Association
	\"T\" Installer Tous les comptes
	\"Q\" Quitter"
read REPONSE
REPONSE=`echo $REPONSE |tr -s a-z A-Z`

  # tester la valeur de resultat (fermeture fenêtre...)
  if [ $REPONSE == "Q" ]
  then 
  	# Sortie
  	exit 1;
  fi
  if [ "$REPONSE" == "E" ] 
  then
  	NBCOMPTES="10";
	INITCOMPTES="1";
  fi
  if [ "$REPONSE" == "A" ]
  then
  	NBCOMPTES="10";
	INITCOMPTES="11";
  fi
  if [ "$REPONSE" == "R" ]
  then
  	NBCOMPTES="20";
	INITCOMPTES="21";
  fi
  if [ "$REPONSE" == "T" ]
  then
  	NBCOMPTES="40";
	INITCOMPTES="1";
  fi
done

QUEFAIRE=""
while [ "$QUEFAIRE" == "" ]; do
	echo -e "Voulez-vous :
	\"I\" Installer les comptes et fichiers de démonstration
	\"D\" Désinstaller les comptes et fichiers de démonstration
	\"Q\" Quitter"
	read REPONSE
	REPONSE=`echo $REPONSE |tr -s a-z A-Z`

  # tester la valeur de resultat (fermeture fenêtre...)
  if [ $REPONSE == "Q" ]
  then 
  	# Sortie
  	exit 1;
  fi
  if [ "$REPONSE" == "I" ] || [ "$REPONSE" == "D" ]
  then
  	QUEFAIRE=$REPONSE;
  fi
done

####################### Partie Pour Installation
if [ $QUEFAIRE == "I" ]
	then
	
	REPGROUPEDEMO=""
	REPMOTDEPASSE=""
	echo -e "Indiquer ici le nom du groupe (groupedemo, par défaut) :"
	read REPGROUPEDEMO
	echo -e "Indiquer maintenant le mot de passe pour tous les comptes :"
	echo -e " \"entre\", par defaut"
	read REPMOTDEPASSE
	 # tester la valeur de resultat (fermeture fenêtre...)
  	if [ ! $REPGROUPEDEMO == "" ] ;
  	then 
  		GROUPEDEMO=$REPGROUPEDEMO
	fi
  	if [ ! $REPMOTDEPASSE == "" ] ;
  	then 
  		MOTDEPASSE=$REPMOTDEPASSE
	fi
	#### Création du groupe de démo
	echo -e " *** ${BLSTAR} ${BL}Création des comptes utilisateurs ${NO} ***" 
	# On teste si le groupe demo existe déjà
		GROUPEXIST=`horizon-getent group | grep " ".$GROUPEDEMO.":"`
		longueur=${#GROUPEXIST}
		if [ "$longueur" == "0" ] ; then
			# S'il n'existe pas, on le crée
			horizon-add group --name $GROUPEDEMO
			echo -e "* On crée le groupe : ${GR}" $GROUPEDEMO "${NO}"
		else 
			# Sortie
			# exit 1;
			echo " le groupe existe déjà";
		fi

	#### Création des comptes utilisateurs
	# Boucle de création des comptes de 1 à 20
	I=$INITCOMPTES
	MAXI=$(( $INITCOMPTES + $NBCOMPTES -1 ))
	while (( I <= "$MAXI" ))
	do
		FIRSTNAME=`echo ${USERSDEMO[$I]} | cut -d ':' -f 1`
		LASTNAME=`echo ${USERSDEMO[$I]} | cut -d ':' -f 2`
		SKEL=`echo ${USERSDEMO[$I]} | cut -d ':' -f 3`
		# on teste si le compte existe déjà :
		USEREXIST=`horizon-getent user | grep $FIRSTNAME':'`
		longueur=${#USEREXIST}

		if [ "$longueur" == "0" ] ; then 
			# On crée le compte
			horizon-add user --login $FIRSTNAME --firstname $FIRSTNAME --lastname $LASTNAME --password $MOTDEPASSE --profile $PROFILE --skel $SKEL
			echo -e " * On crée le compte utilisateur : ${RD}" $FIRSTNAME "${NO} - ${RD}" $LASTNAME "${NO}"
		else 
			echo -e "${RD}" $FIRSTNAME "${NO} existe déjà !"
			echo -e "Attention, il sera remplacé !"
			# read BIDON
		fi
		# Maintenant qu'il existe, on le rend membre du groupe
		horizon-modify user --login $FIRSTNAME --add-groups $GROUPEDEMO
		echo -e "  - On place ${RD}"$FIRSTNAME"${NO} dans ${GR}"$GROUPEDEMO"${NO}"
		# On lui attribue son profil
		# horizon-modify user --login $FIRSTNAME --apply-skel $SKEL
		cp -a $SKEL/* /home/utilisateurs/$FIRSTNAME/
		for F in $PROFILEFILES
		do
			cp -a $SKEL/$F /home/utilisateurs/$FIRSTNAME/
			chown -R $FIRSTNAME /home/utilisateurs/$FIRSTNAME/
			echo 
		done
		# chown -R /home/utilisateurs/$FIRSTNAME
		echo -e "  - On applique le profil de ${RD}"$FIRSTNAME"${NO} : ${YL}" $SKEL "${NO}"
#		horizon-check user --login $FIRSTNAME --auto-yes
		echo -e "  - Droits vérifiés pour ${RD}"$FIRSTNAME"${NO}"
		(( I += 1 ))
		sleep 1
	done
	# reconstruction des alias de mail	
	horizon-rebuild-mail-aliases

	echo -e " *** Fin de création des comptes *** "
	
	#### Création des responsables
	# et attribution des groupes supplémentaires
	# Boucle sur les responsables choisis.
	MAXIRESP=$(( $INITCOMPTES + $NBCOMPTES -1));
# debug	echo "INITCOMPTES $INITCOMPTES / NBCOMPTES : $NBCOMPTES / MAXIRESP : $MAXIRESP"
	for J in $RESPLIST
	do
		echo "J : $J / INITCOMPTES $INITCOMPTES / NBCOMPTES : $NBCOMPTES / MAXIRESP : $MAXIRESP"
			# On récupère les identitiés des responsables
			FIRSTNAME=`echo ${USERSDEMO[$J]} | cut -d ':' -f 1`
			LASTNAME=`echo ${USERSDEMO[$J]} | cut -d ':' -f 2`
			SKEL=`echo ${USERSDEMO[$J]} | cut -d ':' -f 3`
			horizon-modify user --no-colors --login $FIRSTNAME --add-groups resp-$GROUPEDEMO
			echo -e "* On crée les responsables n°"$JQUEFAIRE=""
	while [ "$QUEFAIRE" == "" ]; do
		echo -e "Voulez-vous :
		\"I\" Installer les comptes et fichiers de démonstration
		\"D\" Désinstaller les comptes et fichiers de démonstration
		\"Q\" Quitter"
		read REPONSE
		REPONSE=`echo $REPONSE |tr -s a-z A-Z`

	  # tester la valeur de resultat (fermeture fenêtre...)
        if [ $REPONSE == "Q" ]
	  then 
	  	# Sortie
	  	exit 1;
	  fi
	  if [ "$REPONSE" == "I" ] || [ "$REPONSE" == "D" ]
	  then
	  	QUEFAIRE=$REPONSE;
	  fi
	done

	for k in $GROUPSUPP
	do
		horizon-modify user --no-colors --login $FIRSTNAME --add-groups $k
		echo -e "  - On lui ajoute le groupe ${GR}" $k "${NO}"
	done
     done


	# On récupère l'archive des documents
	
	
	if [ -z "abuledudemo.tar.gz" ] ; then
		rm abuledudemo.tar.gz*
#		wget http://192.168.1.25/abuledudemo.tar.gz
	fi
	wget http://www.webaf.net/docs/abuledudemo.tar.gz
	echo "Téléchargement"
	tar -xzf abuledudemo.tar.gz
	# Copie dans le dossier de démo
	cp -R abuledudemo/* /home/classes/$GROUPEDEMO
	# On récupère le login du propriétaire des fichiers
	LOGINPROP=`echo ${USERSDEMO[$RESP]} | cut -d ':' -f 1`
	# On change les droits
 	chown -R $LOGINPROP /home/classes/$GROUPEDEMO
	rm -rf abuledudemo/
	echo -e "${BLSTAR} Copie des documents dans le dossier de démo"

	echo -e " Rétablissement des bons droits pour tous les documents."
	echo -e "Merci de patienter..."
	horizon-check group -a -b
	echo -e "${BLSTAR} Rétablissement des bons droits pour tous"

fi

####################### Partie pour désinstallation
if [ $QUEFAIRE == "D" ] ;
	then

	# Boucle d'effacement des comptes
	echo -e "${BLSTAR} ${BL}Effacement des comptes ${NO}"
	for ((I = 1 ; I <= "$MAXCOMPTES"; I += 1)) do
		FIRSTNAME=`echo ${USERSDEMO[$I]} | cut -d ':' -f 1`
		# on teste si le compte existe déjà :
		USEREXIST=`horizon-getent user | grep $FIRSTNAME':'`
		longueur=${#USEREXIST}
		
		if [ "$longueur" != "0" ] ; then
			# s'il existe on le supprime
			horizon-delete user --login $FIRSTNAME
			echo -e "  - On efface le compte : ${RD}" $FIRSTNAME "${NO}"
		fi
	done
	# On efface le groupe de demo
	echo -e "${BLSTAR} ${BL}Effacement du groupe ${NO}"
	horizon-delete group --name $GROUPEDEMO
	echo -e "  - On efface le groupe :${RD}" $GROUPEDEMO "${NO}"
fi

	echo -e "${YL} Merci. ${NO}"

